program Median
  use sep

  implicit none
  integer                            :: n1, n2, i1, i2, prev, test1, mutecount
  real                               :: temp, min, test2
  real, dimension (:,:), allocatable :: vel, mute
  real, dimension (:),   allocatable :: medvel

  call sep_init (SOURCE)
  call from_history (n1, n2)
  call sep_close ()

  allocate (vel(n1,n2), medvel(n1), mute(n1,n2))
  call sep_read (vel)
  call sep_read (mute,"mute")

  do i1=1,n1
     min=vel(i1,1)
     mutecount=1

     do i2=2,n2
!        write(0,*) "mute ",mute(i1,i2)
        if (mute(i1,i2)/=1) exit                  !exit loop if you enter mute zone
        mutecount=mutecount+1
        temp=vel(i1,i2)
        if (temp < min) then
           vel(i1,i2)=min
           min=temp
        endif
     enddo
     vel(i1,1)=min                                !put minimum value first

     do i2=3,n2                                   !sort the rest
        if (mute(i1,i2)/=1) exit                  !exit loop if you enter mute zone
        temp=vel(i1,i2)
        prev=i2-1
        if (temp < vel(i1,prev)) then
           vel(i1,i2) = vel(i1,prev)
           prev=prev-1
           do
              if (temp >= vel(i1,prev)) exit
              vel(i1,prev+1)=vel(i1,prev)
              prev=prev-1
           enddo
           vel(i1,prev+1)=temp
        endif
     enddo
     write(0,*) "mutecount ", mutecount
     test1=mutecount/2
     test2=mutecount/2
     if (test1 == test2) then                         !get median value
        do i2=1,n1
           medvel(i2)= (vel(i2,test1)+vel(i2,test1+1))/2
        enddo
     else
        do i2=1,n1
           medvel(i2)= vel(i2,test1+1)
        enddo
     endif
  enddo

!  test1=n2/2
!  test2=n2/2
!write(0,*) "test1 ",test1
!write(0,*) "test2 ",test2

!  if (test1 == test2) then                         !get median value
!     do i1=1,n1
!        medvel(i1)= (vel(i1,test1)+vel(i1,test1+1))/2
!        write(0,*) vel(i1,test1),vel(i1,test1+1),medvel(i1)
!     enddo
!  else
!     do i1=1,n1
!        medvel(i1)= vel(i1,test1+1)
!     enddo
!  endif

!do i1=1,n1
!write(0,*) "medvel ",medvel(i1)
!enddo

  call sep_write (medvel)
!  call sep_write (vel)
  deallocate (vel,medvel,mute)

end program Median



